<template>
    <i-form :model="this.data" class='app-form info-form-mode' ref='form'  id='form' style="">
    <input style="display:none;" />
    <row >
    <tabs :animated="false" name='form' :value="detailsModel.form.activiedPage" 
        @on-click="detailsModel.form.clickPage($event)">
            <tab-pane v-show="detailsModel.formpage1.visible" name='formpage1' :index="0" tab='form' class=''  
                :label="(h) =>{
                    return h('span',{
                        class:'caption'
                    },[
                    $t('entities.emwo_en.main2_form.details.formpage1')
                    ])
                }">
                    
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwo_en.main2_form.details.grouppanel2')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.emwo_enid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='emwo_enid' :itemRules="this.rules.emwo_enid" class='' :caption="$t('entities.emwo_en.main2_form.details.emwo_enid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.emwo_enid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='emwo_enid'
:value="data.emwo_enid" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.emwo_enname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='emwo_enname' :itemRules="this.rules.emwo_enname" class='' :caption="$t('entities.emwo_en.main2_form.details.emwo_enname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.emwo_enname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='emwo_enname'
:value="data.emwo_enname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.equipname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='equipname' :itemRules="this.rules.equipname" class='' :caption="$t('entities.emwo_en.main2_form.details.equipname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equipname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='equipname'
:value="data.equipname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.objname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='objname' :itemRules="this.rules.objname" class='' :caption="$t('entities.emwo_en.main2_form.details.objname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.objname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='objname'
:value="data.objname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wodate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wodate' :itemRules="this.rules.wodate" class='' :caption="$t('entities.emwo_en.main2_form.details.wodate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wodate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wodate'
:value="data.wodate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.activelengths.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='activelengths' :itemRules="this.rules.activelengths" class='' :caption="$t('entities.emwo_en.main2_form.details.activelengths')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.activelengths.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='activelengths'
:value="data.activelengths" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel9.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel9.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwo_en.main2_form.details.grouppanel9')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.dpname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='dpname' :itemRules="this.rules.dpname" class='' :caption="$t('entities.emwo_en.main2_form.details.dpname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.dpname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='dpname'
:value="data.dpname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wpersonname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wpersonname' :itemRules="this.rules.wpersonname" class='' :caption="$t('entities.emwo_en.main2_form.details.wpersonname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wpersonname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wpersonname'
:value="data.wpersonname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.bdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='bdate' :itemRules="this.rules.bdate" class='' :caption="$t('entities.emwo_en.main2_form.details.bdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.bdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='bdate'
:value="data.bdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.regionbegindate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='regionbegindate' :itemRules="this.rules.regionbegindate" class='' :caption="$t('entities.emwo_en.main2_form.details.regionbegindate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.regionbegindate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='regionbegindate'
:value="data.regionbegindate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.lastval.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='lastval' :itemRules="this.rules.lastval" class='' :caption="$t('entities.emwo_en.main2_form.details.lastval')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.lastval.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='lastval'
:value="data.lastval" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.curval.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='curval' :itemRules="this.rules.curval" class='' :caption="$t('entities.emwo_en.main2_form.details.curval')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.curval.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='curval'
:value="data.curval" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.vrate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='vrate' :itemRules="this.rules.vrate" class='' :caption="$t('entities.emwo_en.main2_form.details.vrate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.vrate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='vrate'
:value="data.vrate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.nval.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='nval' :itemRules="this.rules.nval" class='' :caption="$t('entities.emwo_en.main2_form.details.nval')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.nval.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='nval'
:value="data.nval" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel18.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel18.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwo_en.main2_form.details.grouppanel18')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.rempname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rempname' :itemRules="this.rules.rempname" class='' :caption="$t('entities.emwo_en.main2_form.details.rempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rempname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='rempname'
:value="data.rempname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.rdeptname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rdeptname' :itemRules="this.rules.rdeptname" class='' :caption="$t('entities.emwo_en.main2_form.details.rdeptname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rdeptname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='rdeptname'
:value="data.rdeptname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.recvpersonname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='recvpersonname' :itemRules="this.rules.recvpersonname" class='' :caption="$t('entities.emwo_en.main2_form.details.recvpersonname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.recvpersonname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='recvpersonname'
:value="data.recvpersonname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.mpersonname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='mpersonname' :itemRules="this.rules.mpersonname" class='' :caption="$t('entities.emwo_en.main2_form.details.mpersonname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.mpersonname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='mpersonname'
:value="data.mpersonname" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


            </tab-pane> 
            <tab-pane v-show="detailsModel.formpage23.visible" name='formpage23' :index="1" tab='form' class=''  
                :label="(h) =>{
                    return h('span',{
                        class:'caption'
                    },[
                    $t('entities.emwo_en.main2_form.details.formpage23')
                    ])
                }">
                    
<i-col v-show="detailsModel.grouppanel24.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel24.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwo_en.main2_form.details.grouppanel24')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.wogroup.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wogroup' :itemRules="this.rules.wogroup" class='' :caption="$t('entities.emwo_en.main2_form.details.wogroup')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wogroup.error" :isEmptyCaption="false" labelPos="LEFT">
    <i-input v-model="data.wogroup" readonly disabled style=""></i-input>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wopname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wopname' :itemRules="this.rules.wopname" class='' :caption="$t('entities.emwo_en.main2_form.details.wopname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wopname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wopname'
:value="data.wopname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wooriname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wooriname' :itemRules="this.rules.wooriname" class='' :caption="$t('entities.emwo_en.main2_form.details.wooriname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wooriname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wooriname'
:value="data.wooriname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wooritype.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wooritype' :itemRules="this.rules.wooritype" class='' :caption="$t('entities.emwo_en.main2_form.details.wooritype')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wooritype.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wooritype'
:value="data.wooritype" tag='EMWOORITYPE' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel29.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel29.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwo_en.main2_form.details.grouppanel29')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.orgid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='orgid' :itemRules="this.rules.orgid" class='' :caption="$t('entities.emwo_en.main2_form.details.orgid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.orgid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='orgid'
:value="data.orgid" tag='PFCL_ORG' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.archive.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='archive' :itemRules="this.rules.archive" class='' :caption="$t('entities.emwo_en.main2_form.details.archive')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.archive.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='archive'
:value="data.archive" tag='EMARCHIVE' codelistType='STATIC' renderMode="STR" valueSeparator=";" textSeparator="、" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.description.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='description' :itemRules="this.rules.description" class='' :caption="$t('entities.emwo_en.main2_form.details.description')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.description.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='description'
:value="data.description" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createman' :itemRules="this.rules.createman" class='' :caption="$t('entities.emwo_en.main2_form.details.createman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createman'
:value="data.createman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createdate' :itemRules="this.rules.createdate" class='' :caption="$t('entities.emwo_en.main2_form.details.createdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createdate'
:value="data.createdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updateman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updateman' :itemRules="this.rules.updateman" class='' :caption="$t('entities.emwo_en.main2_form.details.updateman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updateman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updateman'
:value="data.updateman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updatedate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updatedate' :itemRules="this.rules.updatedate" class='' :caption="$t('entities.emwo_en.main2_form.details.updatedate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updatedate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updatedate'
:value="data.updatedate" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


            </tab-pane> 
            <tab-pane v-show="detailsModel.formpage37.visible" name='formpage37' :index="2" tab='form' class=''  
                :label="(h) =>{
                    return h('span',{
                        class:'caption'
                    },[
                    $t('entities.emwo_en.main2_form.details.formpage37')
                    ])
                }">
                    
<i-col v-show="detailsModel.content.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-item name='content' :itemRules="this.rules.content" class='' :caption="$t('entities.emwo_en.main2_form.details.content')" uiStyle="DEFAULT" :labelWidth="0" :isShowCaption="false" :error="detailsModel.content.error" :isEmptyCaption="false" labelPos="NONE">
    <app-span   name='content'
:value="data.content" style=""></app-span>
</app-form-item>

</i-col>


            </tab-pane> 
    </tabs>
    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import EMWO_ENService from '@/service/emwo-en/emwo-en-service';
import Main2Service from './main2-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main2Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main2
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main2
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main2
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main2
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main2
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main2
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main2Service}
     * @memberof Main2
     */
    public service: Main2Service = new Main2Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMWO_ENService}
     * @memberof Main2
     */
    public appEntityService: EMWO_ENService = new EMWO_ENService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main2
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main2
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main2
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main2
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main2
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main2
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main2
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main2
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main2
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main2
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main2
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main2
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        emwo_enid: null,
        emwo_enname: null,
        equipname: null,
        objname: null,
        wodate: null,
        activelengths: null,
        dpname: null,
        wpersonname: null,
        bdate: null,
        regionbegindate: null,
        lastval: null,
        curval: null,
        vrate: null,
        nval: null,
        rempname: null,
        rdeptname: null,
        recvpersonname: null,
        mpersonname: null,
        wogroup: null,
        wopname: null,
        wooriname: null,
        wooritype: null,
        orgid: null,
        archive: null,
        description: null,
        createman: null,
        createdate: null,
        updateman: null,
        updatedate: null,
        content: null,
        emwo_en:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main2
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main2
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main2
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main2
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main2
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '工单编号 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '工单编号 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '工单编号 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '工单编号 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '工单名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '工单名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '工单名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '工单名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        emwo_enid: [
            { type: 'string', message: '工单编号(自动) 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '工单编号(自动) 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '工单编号(自动) 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '工单编号(自动) 值不能为空', trigger: 'blur' },
        ],
        emwo_enname: [
            { type: 'string', message: '工单名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '工单名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '工单名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '工单名称 值不能为空', trigger: 'blur' },
        ],
        equipname: [
            { type: 'string', message: '设备 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备 值不能为空', trigger: 'blur' },
        ],
        objname: [
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'blur' },
        ],
        wodate: [
            { type: 'string', message: '安排日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '安排日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '安排日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '安排日期 值不能为空', trigger: 'blur' },
        ],
        activelengths: [
            { type: 'number', message: '持续时间(H) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '持续时间(H) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '持续时间(H) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '持续时间(H) 值不能为空', trigger: 'blur' },
        ],
        dpname: [
            { type: 'string', message: '能源 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '能源 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '能源 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '能源 值不能为空', trigger: 'blur' },
        ],
        wpersonname: [
            { type: 'string', message: '抄表人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '抄表人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '抄表人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '抄表人 值不能为空', trigger: 'blur' },
        ],
        bdate: [
            { type: 'string', message: '上次采集时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '上次采集时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '上次采集时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '上次采集时间 值不能为空', trigger: 'blur' },
        ],
        regionbegindate: [
            { type: 'string', message: '实际抄表时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '实际抄表时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '实际抄表时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '实际抄表时间 值不能为空', trigger: 'blur' },
        ],
        lastval: [
            { type: 'number', message: '上次记录值 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '上次记录值 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '上次记录值 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '上次记录值 值不能为空', trigger: 'blur' },
        ],
        curval: [
            { type: 'number', message: '本次记录值 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '本次记录值 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '本次记录值 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '本次记录值 值不能为空', trigger: 'blur' },
        ],
        vrate: [
            { type: 'number', message: '倍率 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '倍率 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '倍率 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '倍率 值不能为空', trigger: 'blur' },
        ],
        nval: [
            { type: 'number', message: '抄表值 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '抄表值 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '抄表值 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '抄表值 值不能为空', trigger: 'blur' },
        ],
        rempname: [
            { type: 'string', message: '责任人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任人 值不能为空', trigger: 'blur' },
        ],
        rdeptname: [
            { type: 'string', message: '责任部门 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任部门 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任部门 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任部门 值不能为空', trigger: 'blur' },
        ],
        recvpersonname: [
            { type: 'string', message: '指派抄表人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '指派抄表人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '指派抄表人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '指派抄表人 值不能为空', trigger: 'blur' },
        ],
        mpersonname: [
            { type: 'string', message: '制定人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '制定人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '制定人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '制定人 值不能为空', trigger: 'blur' },
        ],
        wogroup: [
            { type: 'string', message: '工单分组 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '工单分组 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '工单分组 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '工单分组 值不能为空', trigger: 'blur' },
        ],
        wopname: [
            { type: 'string', message: '上级工单 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '上级工单 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '上级工单 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '上级工单 值不能为空', trigger: 'blur' },
        ],
        wooriname: [
            { type: 'string', message: '工单来源 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '工单来源 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '工单来源 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '工单来源 值不能为空', trigger: 'blur' },
        ],
        wooritype: [
            { type: 'string', message: '来源类型 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '来源类型 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '来源类型 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '来源类型 值不能为空', trigger: 'blur' },
        ],
        orgid: [
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'blur' },
        ],
        archive: [
            { type: 'string', message: '归档 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '归档 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '归档 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '归档 值不能为空', trigger: 'blur' },
        ],
        description: [
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'blur' },
        ],
        createman: [
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'blur' },
        ],
        createdate: [
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'blur' },
        ],
        updateman: [
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'blur' },
        ],
        updatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        content: [
            { type: 'string', message: '详细内容 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '详细内容 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '详细内容 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '详细内容 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main2
     */
    public detailsModel: any = {
        grouppanel2: new FormGroupPanelModel({ caption: '工单信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwo_en.main2_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel9: new FormGroupPanelModel({ caption: '执行信息', detailType: 'GROUPPANEL', name: 'grouppanel9', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwo_en.main2_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel18: new FormGroupPanelModel({ caption: '责任信息', detailType: 'GROUPPANEL', name: 'grouppanel18', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwo_en.main2_form', extractMode: 'ITEM', details: [] } })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this })
, 
        grouppanel24: new FormGroupPanelModel({ caption: '高级信息', detailType: 'GROUPPANEL', name: 'grouppanel24', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwo_en.main2_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel29: new FormGroupPanelModel({ caption: '操作信息', detailType: 'GROUPPANEL', name: 'grouppanel29', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwo_en.main2_form', extractMode: 'ITEM', details: [] } })
, 
        formpage23: new FormPageModel({ caption: '其它', detailType: 'FORMPAGE', name: 'formpage23', visible: true, isShowCaption: true, form: this })
, 
        formpage37: new FormPageModel({ caption: '详细信息', detailType: 'FORMPAGE', name: 'formpage37', visible: true, isShowCaption: true, form: this })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '工单编号', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '工单名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        emwo_enid: new FormItemModel({ caption: '工单编号(自动)', detailType: 'FORMITEM', name: 'emwo_enid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        emwo_enname: new FormItemModel({ caption: '工单名称', detailType: 'FORMITEM', name: 'emwo_enname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equipname: new FormItemModel({ caption: '设备', detailType: 'FORMITEM', name: 'equipname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        objname: new FormItemModel({ caption: '位置', detailType: 'FORMITEM', name: 'objname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        wodate: new FormItemModel({ caption: '安排日期', detailType: 'FORMITEM', name: 'wodate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        activelengths: new FormItemModel({ caption: '持续时间(H)', detailType: 'FORMITEM', name: 'activelengths', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        dpname: new FormItemModel({ caption: '能源', detailType: 'FORMITEM', name: 'dpname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        wpersonname: new FormItemModel({ caption: '抄表人', detailType: 'FORMITEM', name: 'wpersonname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        bdate: new FormItemModel({ caption: '上次采集时间', detailType: 'FORMITEM', name: 'bdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        regionbegindate: new FormItemModel({ caption: '实际抄表时间', detailType: 'FORMITEM', name: 'regionbegindate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        lastval: new FormItemModel({ caption: '上次记录值', detailType: 'FORMITEM', name: 'lastval', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        curval: new FormItemModel({ caption: '本次记录值', detailType: 'FORMITEM', name: 'curval', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        vrate: new FormItemModel({ caption: '倍率', detailType: 'FORMITEM', name: 'vrate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        nval: new FormItemModel({ caption: '抄表值', detailType: 'FORMITEM', name: 'nval', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rempname: new FormItemModel({ caption: '责任人', detailType: 'FORMITEM', name: 'rempname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rdeptname: new FormItemModel({ caption: '责任部门', detailType: 'FORMITEM', name: 'rdeptname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        recvpersonname: new FormItemModel({ caption: '指派抄表人', detailType: 'FORMITEM', name: 'recvpersonname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        mpersonname: new FormItemModel({ caption: '制定人', detailType: 'FORMITEM', name: 'mpersonname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        wogroup: new FormItemModel({ caption: '工单分组', detailType: 'FORMITEM', name: 'wogroup', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 1 })
, 
        wopname: new FormItemModel({ caption: '上级工单', detailType: 'FORMITEM', name: 'wopname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        wooriname: new FormItemModel({ caption: '工单来源', detailType: 'FORMITEM', name: 'wooriname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        wooritype: new FormItemModel({ caption: '来源类型', detailType: 'FORMITEM', name: 'wooritype', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        orgid: new FormItemModel({ caption: '组织', detailType: 'FORMITEM', name: 'orgid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        archive: new FormItemModel({ caption: '归档', detailType: 'FORMITEM', name: 'archive', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        description: new FormItemModel({ caption: '描述', detailType: 'FORMITEM', name: 'description', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        createman: new FormItemModel({ caption: '建立人', detailType: 'FORMITEM', name: 'createman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        createdate: new FormItemModel({ caption: '建立时间', detailType: 'FORMITEM', name: 'createdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updateman: new FormItemModel({ caption: '更新人', detailType: 'FORMITEM', name: 'updateman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'updatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        content: new FormItemModel({ caption: '详细内容', detailType: 'FORMITEM', name: 'content', visible: true, isShowCaption: false, form: this, disabled: false, enableCond: 3 })
, 
        form: new FormTabPanelModel({ caption: 'form', detailType: 'TABPANEL', name: 'form', visible: true, isShowCaption: true, form: this, tabPages: [{ name: 'formpage1', index: 0, visible: true }, { name: 'formpage23', index: 1, visible: true }, { name: 'formpage37', index: 2, visible: true }] }),
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emwo_enid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.emwo_enid')
    onEmwo_enidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emwo_enid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emwo_enname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.emwo_enname')
    onEmwo_ennameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emwo_enname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equipname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.equipname')
    onEquipnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equipname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 objname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.objname')
    onObjnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'objname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wodate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.wodate')
    onWodateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wodate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 activelengths 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.activelengths')
    onActivelengthsChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'activelengths', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 dpname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.dpname')
    onDpnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'dpname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wpersonname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.wpersonname')
    onWpersonnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wpersonname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 bdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.bdate')
    onBdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'bdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 regionbegindate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.regionbegindate')
    onRegionbegindateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'regionbegindate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 lastval 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.lastval')
    onLastvalChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'lastval', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 curval 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.curval')
    onCurvalChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'curval', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 vrate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.vrate')
    onVrateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'vrate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 nval 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.nval')
    onNvalChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'nval', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.rempname')
    onRempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rdeptname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.rdeptname')
    onRdeptnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rdeptname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 recvpersonname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.recvpersonname')
    onRecvpersonnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'recvpersonname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 mpersonname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.mpersonname')
    onMpersonnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'mpersonname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wogroup 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.wogroup')
    onWogroupChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wogroup', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wopname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.wopname')
    onWopnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wopname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wooriname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.wooriname')
    onWoorinameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wooriname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wooritype 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.wooritype')
    onWooritypeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wooritype', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 orgid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.orgid')
    onOrgidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'orgid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 archive 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.archive')
    onArchiveChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'archive', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 description 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.description')
    onDescriptionChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'description', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.createman')
    onCreatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.createdate')
    onCreatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updateman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.updateman')
    onUpdatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updateman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.updatedate')
    onUpdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 content 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.content')
    onContentChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'content', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main2
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
      * @memberof EditForm
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main2
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                














































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main2
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main2
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.emwo_en){
            Object.assign(this.context,{emwo_en:data.emwo_en})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main2
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main2
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main2
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main2
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main2
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main2
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main2
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main2
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main2
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main2
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main2
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main2
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    this.loadDraft(data);
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main2
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main2
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main2
     */
    public copy(arg: any = {}): void {
        this.loadDraft(arg);
    }

    /**
     *打印
     *@memberof @memberof Main2
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'form',popTitle:'能耗工单<主信息>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main2
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main2
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMWO_ENEditView视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main2
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMWO_ENEditView视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.emwo_en){
                Object.assign(this.context,{emwo_en:data.emwo_en})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main2
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMWO_ENEditView视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main2
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMWO_ENEditView视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof EditForm
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMWO_ENEditView视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main2
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main2
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.emwo_en || Object.is(arg.emwo_en, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main2
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main2
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main2
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter > 0){
            return;
        }
        this.save(this.drsaveopt, undefined, false).then((res) =>{
            this.saveState(res);
            this.drsaveopt = {};
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    _this.closeView(res.data);
                }
            }
        });
    }

    /**
     * 新建默认值
     * @memberof Main2
     */
    public createDefault(){                    
    }

    /**
     * 更新默认值
     * @memberof Main2
     */
    public updateDefault(){                    
        if (this.data.hasOwnProperty('wpersonname') && !this.data.wpersonname) {
            this.data['wpersonname'] = this.context['srfuserid'];
        }
        if (this.data.hasOwnProperty('recvpersonname') && !this.data.recvpersonname) {
            this.data['recvpersonname'] = this.context['srfuserid'];
        }
    }

    
}
</script>

<style lang='less'>
@import './main2-form.less';
</style>